unit Main;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,

  ONE.Objects,

  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Objects,
  FMX.Controls.Presentation, FMX.StdCtrls, FMX.Layouts;

type
  TForm1 = class(TForm)
    RoundRect1: TRoundRect;
    Rectangle1: TRectangle;
    ToolBar1: TToolBar;
    Text1: TText;
    ProportionalChk: TCheckBox;
    Layout1: TLayout;
    procedure FormCreate(Sender: TObject);
    procedure Rectangle1Click(Sender: TObject);
    procedure ProportionalChkChange(Sender: TObject);
  private
    { Private declarations }
  public
    Selection1: TOneSelection;
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

procedure TForm1.FormCreate(Sender: TObject);
begin
     Selection1 := TOneSelection.Create(Self);
     Selection1.GripSize := 8;
     Selection1.Proportional := True;
     Layout1.AddObject(Selection1);

     Rectangle1Click(Rectangle1);
end;

procedure TForm1.ProportionalChkChange(Sender: TObject);
begin
     Selection1.Proportional := ProportionalChk.IsChecked;
end;

procedure TForm1.Rectangle1Click(Sender: TObject);
var c: TControl;
begin
     if Selection1.ChildrenCount > 0 then
     begin
          c                := TControl(Selection1.Children[0]);
          c.HitTest        := True;
          c.Align          := TAlignLayout.None;
          c.Parent         := Layout1;
          c.BoundsRect     := Selection1.BoundsRect;
          c.Position.Point := Selection1.Position.Point;
     end;

     Selection1.BoundsRect     := TControl(Sender).BoundsRect;
     Selection1.Position.Point := TControl(Sender).Position.Point;
     Selection1.Visible        := True;
     Selection1.BringToFront;

     TControl(Sender).Parent  := Selection1;
     TControl(Sender).Align   := TAlignLayout.Client;
     TControl(Sender).HitTest := False;
end;

end.
